import { SENSITIVE_STRING } from "@aws-sdk/smithy-client";
import { ResponseLaunchTemplateDataFilterSensitiveLog, } from "./models_1";
export var VolumeModificationState;
(function (VolumeModificationState) {
    VolumeModificationState["completed"] = "completed";
    VolumeModificationState["failed"] = "failed";
    VolumeModificationState["modifying"] = "modifying";
    VolumeModificationState["optimizing"] = "optimizing";
})(VolumeModificationState || (VolumeModificationState = {}));
export var VolumeStatusName;
(function (VolumeStatusName) {
    VolumeStatusName["io_enabled"] = "io-enabled";
    VolumeStatusName["io_performance"] = "io-performance";
})(VolumeStatusName || (VolumeStatusName = {}));
export var VolumeStatusInfoStatus;
(function (VolumeStatusInfoStatus) {
    VolumeStatusInfoStatus["impaired"] = "impaired";
    VolumeStatusInfoStatus["insufficient_data"] = "insufficient-data";
    VolumeStatusInfoStatus["ok"] = "ok";
})(VolumeStatusInfoStatus || (VolumeStatusInfoStatus = {}));
export var VpcAttributeName;
(function (VpcAttributeName) {
    VpcAttributeName["enableDnsHostnames"] = "enableDnsHostnames";
    VpcAttributeName["enableDnsSupport"] = "enableDnsSupport";
    VpcAttributeName["enableNetworkAddressUsageMetrics"] = "enableNetworkAddressUsageMetrics";
})(VpcAttributeName || (VpcAttributeName = {}));
export var TransitGatewayPropagationState;
(function (TransitGatewayPropagationState) {
    TransitGatewayPropagationState["disabled"] = "disabled";
    TransitGatewayPropagationState["disabling"] = "disabling";
    TransitGatewayPropagationState["enabled"] = "enabled";
    TransitGatewayPropagationState["enabling"] = "enabling";
})(TransitGatewayPropagationState || (TransitGatewayPropagationState = {}));
export var ClientCertificateRevocationListStatusCode;
(function (ClientCertificateRevocationListStatusCode) {
    ClientCertificateRevocationListStatusCode["active"] = "active";
    ClientCertificateRevocationListStatusCode["pending"] = "pending";
})(ClientCertificateRevocationListStatusCode || (ClientCertificateRevocationListStatusCode = {}));
export var UnlimitedSupportedInstanceFamily;
(function (UnlimitedSupportedInstanceFamily) {
    UnlimitedSupportedInstanceFamily["t2"] = "t2";
    UnlimitedSupportedInstanceFamily["t3"] = "t3";
    UnlimitedSupportedInstanceFamily["t3a"] = "t3a";
    UnlimitedSupportedInstanceFamily["t4g"] = "t4g";
})(UnlimitedSupportedInstanceFamily || (UnlimitedSupportedInstanceFamily = {}));
export var PartitionLoadFrequency;
(function (PartitionLoadFrequency) {
    PartitionLoadFrequency["DAILY"] = "daily";
    PartitionLoadFrequency["MONTHLY"] = "monthly";
    PartitionLoadFrequency["NONE"] = "none";
    PartitionLoadFrequency["WEEKLY"] = "weekly";
})(PartitionLoadFrequency || (PartitionLoadFrequency = {}));
export var IpamComplianceStatus;
(function (IpamComplianceStatus) {
    IpamComplianceStatus["compliant"] = "compliant";
    IpamComplianceStatus["ignored"] = "ignored";
    IpamComplianceStatus["noncompliant"] = "noncompliant";
    IpamComplianceStatus["unmanaged"] = "unmanaged";
})(IpamComplianceStatus || (IpamComplianceStatus = {}));
export var IpamOverlapStatus;
(function (IpamOverlapStatus) {
    IpamOverlapStatus["ignored"] = "ignored";
    IpamOverlapStatus["nonoverlapping"] = "nonoverlapping";
    IpamOverlapStatus["overlapping"] = "overlapping";
})(IpamOverlapStatus || (IpamOverlapStatus = {}));
export var IpamAddressHistoryResourceType;
(function (IpamAddressHistoryResourceType) {
    IpamAddressHistoryResourceType["eip"] = "eip";
    IpamAddressHistoryResourceType["instance"] = "instance";
    IpamAddressHistoryResourceType["network_interface"] = "network-interface";
    IpamAddressHistoryResourceType["subnet"] = "subnet";
    IpamAddressHistoryResourceType["vpc"] = "vpc";
})(IpamAddressHistoryResourceType || (IpamAddressHistoryResourceType = {}));
export var IpamDiscoveryFailureCode;
(function (IpamDiscoveryFailureCode) {
    IpamDiscoveryFailureCode["assume_role_failure"] = "assume-role-failure";
    IpamDiscoveryFailureCode["throttling_failure"] = "throttling-failure";
    IpamDiscoveryFailureCode["unauthorized_failure"] = "unauthorized-failure";
})(IpamDiscoveryFailureCode || (IpamDiscoveryFailureCode = {}));
export var IpamResourceType;
(function (IpamResourceType) {
    IpamResourceType["eip"] = "eip";
    IpamResourceType["ipv6_pool"] = "ipv6-pool";
    IpamResourceType["public_ipv4_pool"] = "public-ipv4-pool";
    IpamResourceType["subnet"] = "subnet";
    IpamResourceType["vpc"] = "vpc";
})(IpamResourceType || (IpamResourceType = {}));
export var IpamManagementState;
(function (IpamManagementState) {
    IpamManagementState["ignored"] = "ignored";
    IpamManagementState["managed"] = "managed";
    IpamManagementState["unmanaged"] = "unmanaged";
})(IpamManagementState || (IpamManagementState = {}));
export const GetLaunchTemplateDataResultFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.LaunchTemplateData && {
        LaunchTemplateData: ResponseLaunchTemplateDataFilterSensitiveLog(obj.LaunchTemplateData),
    }),
});
export const GetVpnConnectionDeviceSampleConfigurationResultFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.VpnConnectionDeviceSampleConfiguration && { VpnConnectionDeviceSampleConfiguration: SENSITIVE_STRING }),
});
export const DiskImageDetailFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.ImportManifestUrl && { ImportManifestUrl: SENSITIVE_STRING }),
});
export const DiskImageFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Image && { Image: DiskImageDetailFilterSensitiveLog(obj.Image) }),
});
export const UserDataFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const ImportInstanceLaunchSpecificationFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.UserData && { UserData: SENSITIVE_STRING }),
});
export const ImportInstanceRequestFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.DiskImages && { DiskImages: obj.DiskImages.map((item) => DiskImageFilterSensitiveLog(item)) }),
    ...(obj.LaunchSpecification && {
        LaunchSpecification: ImportInstanceLaunchSpecificationFilterSensitiveLog(obj.LaunchSpecification),
    }),
});
