import { SENSITIVE_STRING } from "@aws-sdk/smithy-client";
import { SpotFleetRequestConfigDataFilterSensitiveLog, SpotInstanceRequestFilterSensitiveLog, } from "./models_4";
import { DiskImageDetailFilterSensitiveLog, } from "./models_5";
export var ModifyAvailabilityZoneOptInStatus;
(function (ModifyAvailabilityZoneOptInStatus) {
    ModifyAvailabilityZoneOptInStatus["not_opted_in"] = "not-opted-in";
    ModifyAvailabilityZoneOptInStatus["opted_in"] = "opted-in";
})(ModifyAvailabilityZoneOptInStatus || (ModifyAvailabilityZoneOptInStatus = {}));
export var OperationType;
(function (OperationType) {
    OperationType["add"] = "add";
    OperationType["remove"] = "remove";
})(OperationType || (OperationType = {}));
export var UnsuccessfulInstanceCreditSpecificationErrorCode;
(function (UnsuccessfulInstanceCreditSpecificationErrorCode) {
    UnsuccessfulInstanceCreditSpecificationErrorCode["INCORRECT_INSTANCE_STATE"] = "IncorrectInstanceState";
    UnsuccessfulInstanceCreditSpecificationErrorCode["INSTANCE_CREDIT_SPECIFICATION_NOT_SUPPORTED"] = "InstanceCreditSpecification.NotSupported";
    UnsuccessfulInstanceCreditSpecificationErrorCode["INSTANCE_NOT_FOUND"] = "InvalidInstanceID.NotFound";
    UnsuccessfulInstanceCreditSpecificationErrorCode["INVALID_INSTANCE_ID"] = "InvalidInstanceID.Malformed";
})(UnsuccessfulInstanceCreditSpecificationErrorCode || (UnsuccessfulInstanceCreditSpecificationErrorCode = {}));
export var HostTenancy;
(function (HostTenancy) {
    HostTenancy["dedicated"] = "dedicated";
    HostTenancy["host"] = "host";
})(HostTenancy || (HostTenancy = {}));
export var TargetStorageTier;
(function (TargetStorageTier) {
    TargetStorageTier["archive"] = "archive";
})(TargetStorageTier || (TargetStorageTier = {}));
export var TrafficMirrorFilterRuleField;
(function (TrafficMirrorFilterRuleField) {
    TrafficMirrorFilterRuleField["description"] = "description";
    TrafficMirrorFilterRuleField["destination_port_range"] = "destination-port-range";
    TrafficMirrorFilterRuleField["protocol"] = "protocol";
    TrafficMirrorFilterRuleField["source_port_range"] = "source-port-range";
})(TrafficMirrorFilterRuleField || (TrafficMirrorFilterRuleField = {}));
export var TrafficMirrorSessionField;
(function (TrafficMirrorSessionField) {
    TrafficMirrorSessionField["description"] = "description";
    TrafficMirrorSessionField["packet_length"] = "packet-length";
    TrafficMirrorSessionField["virtual_network_id"] = "virtual-network-id";
})(TrafficMirrorSessionField || (TrafficMirrorSessionField = {}));
export var VpcTenancy;
(function (VpcTenancy) {
    VpcTenancy["default"] = "default";
})(VpcTenancy || (VpcTenancy = {}));
export var Status;
(function (Status) {
    Status["inClassic"] = "InClassic";
    Status["inVpc"] = "InVpc";
    Status["moveInProgress"] = "MoveInProgress";
})(Status || (Status = {}));
export var ReportInstanceReasonCodes;
(function (ReportInstanceReasonCodes) {
    ReportInstanceReasonCodes["instance_stuck_in_state"] = "instance-stuck-in-state";
    ReportInstanceReasonCodes["not_accepting_credentials"] = "not-accepting-credentials";
    ReportInstanceReasonCodes["other"] = "other";
    ReportInstanceReasonCodes["password_not_available"] = "password-not-available";
    ReportInstanceReasonCodes["performance_ebs_volume"] = "performance-ebs-volume";
    ReportInstanceReasonCodes["performance_instance_store"] = "performance-instance-store";
    ReportInstanceReasonCodes["performance_network"] = "performance-network";
    ReportInstanceReasonCodes["performance_other"] = "performance-other";
    ReportInstanceReasonCodes["unresponsive"] = "unresponsive";
})(ReportInstanceReasonCodes || (ReportInstanceReasonCodes = {}));
export var ReportStatusType;
(function (ReportStatusType) {
    ReportStatusType["impaired"] = "impaired";
    ReportStatusType["ok"] = "ok";
})(ReportStatusType || (ReportStatusType = {}));
export var ResetFpgaImageAttributeName;
(function (ResetFpgaImageAttributeName) {
    ResetFpgaImageAttributeName["loadPermission"] = "loadPermission";
})(ResetFpgaImageAttributeName || (ResetFpgaImageAttributeName = {}));
export var ResetImageAttributeName;
(function (ResetImageAttributeName) {
    ResetImageAttributeName["launchPermission"] = "launchPermission";
})(ResetImageAttributeName || (ResetImageAttributeName = {}));
export var MembershipType;
(function (MembershipType) {
    MembershipType["igmp"] = "igmp";
    MembershipType["static"] = "static";
})(MembershipType || (MembershipType = {}));
export const ImportVolumeRequestFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Image && { Image: DiskImageDetailFilterSensitiveLog(obj.Image) }),
});
export const RequestSpotFleetRequestFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.SpotFleetRequestConfig && {
        SpotFleetRequestConfig: SpotFleetRequestConfigDataFilterSensitiveLog(obj.SpotFleetRequestConfig),
    }),
});
export const RequestSpotLaunchSpecificationFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.UserData && { UserData: SENSITIVE_STRING }),
});
export const RequestSpotInstancesRequestFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.LaunchSpecification && {
        LaunchSpecification: RequestSpotLaunchSpecificationFilterSensitiveLog(obj.LaunchSpecification),
    }),
});
export const RequestSpotInstancesResultFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.SpotInstanceRequests && {
        SpotInstanceRequests: obj.SpotInstanceRequests.map((item) => SpotInstanceRequestFilterSensitiveLog(item)),
    }),
});
export const RunInstancesRequestFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.UserData && { UserData: SENSITIVE_STRING }),
});
export const ScheduledInstancesLaunchSpecificationFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const RunScheduledInstancesRequestFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.LaunchSpecification && { LaunchSpecification: SENSITIVE_STRING }),
});
